﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Collections;
using Telerik.Reporting.Processing;

namespace ExportReportToFile {
  public partial class Form1 : Form {
    public Form1() {
      InitializeComponent();
      reportViewer1.RefreshReport();
    }

    private void radButton1_Click(object sender, EventArgs e) {
      SaveReport(@"C:\Sample.PDF");
    }

    private void SaveReport(string fileLocation) {
      ReportProcessor reportProcessor = new ReportProcessor();
      //pass the reportViewer1's "Report" object to the RenderReport method
      //populate the HashTable if you need to specify DeviceInfo properties, otherwise just pass an empty one like I've done here
      RenderingResult renderingResult = reportProcessor.RenderReport("PDF", reportViewer1.Report, new Hashtable());
      //now just create a filestream and write the DocumentBytes array to it - flush and close, and your file is ready.
      using (FileStream destinationFileStream = new FileStream(fileLocation, FileMode.Create, FileAccess.Write)) {
        destinationFileStream.Write(renderingResult.DocumentBytes, 0, renderingResult.DocumentBytes.GetLength(0));
        destinationFileStream.Flush();
        destinationFileStream.Close();
      }
    }

  }
}
